//********************************************************************
//  Customer.java       Author: Ryo (Rio) Akasaka
//  
//  Last modified: Wed Feb 6, 2007 17:55
//
//  Description: Customer object that contains information about
//  each customer.
//
//********************************************************************

public class Customer
{  
  private int[] list;
  public Customer (int carnum, int clock)
  {
    list = new int [5];
    list[0] = carnum; // Car number
    list[1] = clock; // Arrival time
    list[4] = 0; // Time in queue
  }

  // Time it takes to service car
  public void setservice(int setserv) { list[2] = setserv; } 

  // Sets time when the car is done
  public void servtime(int settime) { list[3] = (list[2] + settime); }
  
  // Calculates total time, from arrival to end of servicing
  public void totaltime (int clock) { list[3] = (clock - list[1]); }
  
  // Increments time customer is waiting impatiently in queue
  public void inqueue() { list[4]++; }

  // Returns any value requested
  public int getinfo(int info) { return list[info]; }

}
