//********************************************************************
//  Queue.java       Author: Ryo (Rio) Akasaka
//  
//  Last modified: Wed Feb 6, 2007 17:57
//
//  Description: Creates a queue for the number of cars waiting in line
//  at a gas station. Returns also the first car in the line. Weiss
//  p.547 was consulted.
//
//********************************************************************

public class Queue
{  
  private Object[] elems;
  private int maxsize, frontnum, realsize = 0, back;

  public Queue (int msize)
  {
    elems = new Object [maxsize = msize];
    frontnum = 0;
    back = frontnum - 1;
  }

  // Returns customer object in line. 
  public Object getnum(int number) { return elems[(frontnum + number) % maxsize]; }

  public Object getfirst() { return elems[frontnum]; }

  public void enqueue(Object incoming)
  {
    back = (back + 1) % maxsize;
    elems[back] = incoming;
    realsize++;
   }
  public Object dequeue()
  {
    Object front = elems[frontnum];
    frontnum = (frontnum + 1) % maxsize;
    realsize--;
    return front;
  }
  public int size() { return realsize; }

  public Boolean isEmpty() { return realsize == 0; }
}
